require 'spec_helper'

describe Stacko::Application do
  def new_application
    klass = Class.new(Stacko::Application) do
      use BeaverMiddleware

      map(:method_name_1) do
        use DogMiddleware
        run lambda { |env| env['ARGUMENTS'].push(:meth1); env['ARGUMENTS'] }
      end

      map(:method_name_2) do
        use HorseMiddleware
        run lambda { |env| env['ARGUMENTS'].push(:meth2); env['ARGUMENTS'] }
      end

      run lambda { |env| env['ARGUMENTS'].push(:defaultapp); env['ARGUMENTS'] }
    end
    klass.new
  end

  it 'defined methods for each mapping' do
    app = new_application
    app.respond_to?(:method_name_1)
    app.respond_to?(:method_name_2)
  end

  it 'responds to call' do
    app = new_application
    app.respond_to?(:call)
  end

  it 'correctly chains apps' do
    app = new_application
    app.call.must_equal([:beaver_middleware, :defaultapp])
    app.method_name_1.must_equal([:beaver_middleware, :dog_middleware, :meth1])
    app.method_name_2.must_equal([:beaver_middleware, :horse_middleware, :meth2])
  end
end