require 'spec_helper'

describe Stacko::MethodMap do
  it 'dispatches map correctly' do
    map = Stacko::MethodMap.new(
      :method_1 => Proc.new{ |env| 'method_1 called' },
      :method_2 => Proc.new{ |env| 'method_2 called' }
    )
    
    env = new_env(:method_1)
    map.call(env).must_equal('method_1 called')

    env = new_env(:method_2)
    map.call(env).must_equal('method_2 called')
  end

  it 'complains when map not found' do
    map = Stacko::MethodMap.new(
      :method_1 => Proc.new{ |env| 'method_1 called' }
    )
    
    env = new_env(:non_existant_method)
    proc { map.call(env) }.must_raise(Stacko::NoMethodError)
  end

  def new_env(method_name)
    {'METHOD_NAME' => method_name}
  end
end